// C. Herzog fuer Grundlagen der Programmierung, 1.12.2004

class OrderedList {

// Attribute:

    private Comparable item;		// Inhalt des listenelements
    private OrderedList next;		// Verweis auf nchstes Element

// Konstruktor:

    // Inhalt und Nachfolgeelement werden als Parameter bergeben:
    private OrderedList (Comparable item, OrderedList next) {
	this.item = item;
	this.next = next;
    }

// Klassenmethoden:

   // length liefert die Laenge einer Liste:
   public static int length (OrderedList l) {
      if (l == null)
         return 0;
      return 1 + length(l.next);
   }

   // Test, ob ein Element in sortierter Liste enthalten ist:
   public static boolean isElement (Comparable c, OrderedList l) {

      // Falls die Liste leer ist oder nur groessere Elemente enthlt:
      if (l == null || l.item.compareTo(c) == 1)
         return false;

      // Falls das erste Listenelement c enthaelt:
      if (l.item.compareTo(c) == 0)
         return true;

      // Ansonsten arbeite rekursiv mit der Nachfolger-liste:
      return isElement(c, l.next);
   }

   // Einfuegen eines Elementes in sortierte Liste:
   public static OrderedList insertElement (Comparable c, OrderedList l) {

      // Falls die Liste leer ist oder nur groessere Elemente enthlt:
      if (l == null || l.item.compareTo(c) == 1) {
	 return new OrderedList(c, l);
      }

      // Falls das erste Listenelement c enthaelt:
      if (l.item.compareTo(c) == 0) {
         System.out.println("insertElement: " + c + " schon vorhanden.");
         return l;
      }

      // Ansonsten arbeite rekursiv mit der Nachfolger-liste:
      l.next = insertElement(c, l.next);
      return l;
   }

   // Loeschen eines Elements aus sortierter Liste:
   public static OrderedList deleteElement (Comparable c, OrderedList l) {

      // Falls die Liste leer ist oder nur groessere Elemente enthlt:
      if (l == null || l.item.compareTo(c) == 1) {
         System.out.println("deleteElement: " + c + " nicht vorhanden.");
	 return l;
      }

      // Falls das erste Listenelement c enthaelt:
      if (l.item.compareTo(c) == 0) {
         return l.next;  // Hier wird c durch "Umleitung" geloescht
      }

      // Ansonsten arbeite rekursiv mit der Nachfolger-liste:
      l.next = deleteElement(c, l.next);
      return l;
   }

   // Liefert Kopie einer sortierten Liste:
   public static OrderedList copyList (OrderedList l) {
      if (l == null)
         return null;
      return new OrderedList(l.item, copyList(l.next));
   }

// Sonstige Methoden:

   // liefert Inhalt des Listenelements
   public Comparable getItem() {
      return item;
   }

   // liefert Verweis auf Nachfolger des Listenelements
   public OrderedList getNext() {
      return next;
   }

   // Ausgabefunktion:
   public String toString() {
      if (next == null)
         return "" + item;
      return item + "," + next;
   }
}
