// C. Herzog fuer Grundlagen der Programmierung, 1.12.2004

class OrderedListSet extends OrderedSet {

// Attribute (Datenstruktur):

    private OrderedList list;	// speichert die Elemente der Menge

// Konstruktor fuer eine leere Menge:

    OrderedListSet() {
	list = null;
    }

// Konstruktor, der die Kopie einer Menge liefert:

    // Zuerst ein Konstruktur speziell fuer OrderedListSet:
    public OrderedListSet(OrderedListSet s) {
	list = OrderedList.copyList(s.list);
    }

    // Sonst muss sich der Konstruktur wenig effizient auf insertElement
    // abstuetzen:
    public OrderedListSet(Set s) {
	list = null;
	Enumeration enum = s.getEnumeration();
	while (enum.hasMoreElements()) {
	   list = OrderedList.insertElement((Comparable) enum.nextElement(), list);
	}
    }

// sonstige datenstrukturabhaengige Methoden:

    // effiziente Abfrage, ob Menge leer ist:
    public boolean isEmpty() {
	return list == null;
    }

    // liefert Enumeration ueber die Menge:
    public Enumeration getEnumeration() {
       return new OrderedListSetEnumeration(list);
    }

    // Einfuegen eines Elementes:
    public void insert(Object o) {
        // sttzt sich auf entsprechende Methode von OrderedList:
	list = OrderedList.insertElement((Comparable) o, list);
    }

    // Entfernen eines Elementes:
    public void delete(Object o) {
        // sttzt sich auf entsprechende Methode von OrderedList:
	list = OrderedList.deleteElement((Comparable) o, list);
    }
}
