// C. Herzog fuer Grundlagen der Programmierung, 1.12.2004

abstract class OrderedSet extends Set {

// Methoden, die bei Sortiertheit effizienter implementierbar sind:

    // Abfrage, ob Element enthalten ist:
    public boolean contains(Object o) {

	Comparable c1 = (Comparable) o;

	Enumeration enum = getEnumeration();

	while (enum.hasMoreElements()) {
	   Object item = enum.nextElement();
	   Comparable c2 = (Comparable) item;

	   // Falls gefunden:
	   if (c2.compareTo(c1) == 0)
	      return true;
	   // Ordnung wird ausgenutzt:
	   if (c2.compareTo(c1) == 1)
	      return false;
	}
	// i nicht gefunden:
	return false;
    }

    // Abfrage nach Teilmengeneigenschaft speziell bei sort. Eingabe:
    public boolean isSubset(OrderedSet s) {

	     // Enumeration der Menge selbst:
	Enumeration enum = getEnumeration();
	     // Enumeration der anderen Menge:
	Enumeration enumS = s.getEnumeration();

	while (enum.hasMoreElements()) {
	    Comparable c = (Comparable) enum.nextElement();

	    if (!enumS.hasMoreElements())
	       return false;

	    Comparable cS;

	    // groessere Elemente in s ueberspringen:
	    do {
	       cS = (Comparable) enumS.nextElement();
	    } while (c.compareTo(cS) == 1 && enumS.hasMoreElements());

	    if (c.compareTo(cS) != 0)
	        // Element der Menge kann nicht auch in s sein
		return false;
	}
	// Teilmengeneigenschaft ist nie verletzt:
	return true;
    }
}
